package hls.plugin.weixin.qiye;

import java.io.IOException;
import java.io.InputStream;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.util.Properties;

/**
 * @title DBUtil
 * @Description:
 * @Company:
 * @author jianwen_zheng
 * @date 2016-10-9
 */
public class DBUtil {

	private static String oracleDriver;
	private static String url;
	private static String username;
	private static String password;

	static {
		try {
			get();
			Class.forName(oracleDriver);
		} catch (ClassNotFoundException e) {
			System.out.println("..");
		}
	}

	/**
	 * 
	 */
	public DBUtil() {
	}

	public InputStream getPathName(String pathName) {
		return DBUtil.class.getClassLoader().getResourceAsStream(pathName);// "com/wx/util/data_jdbc.properties"
	}

	private static void get() {
		Properties prop = new Properties();
		InputStream in = null;
		try {
			in = new DBUtil().getPathName("hls/plugin/weixin/qiye/data_jdbc.properties");
			prop.load(in); // /б
			oracleDriver = prop.getProperty("oracleDriver");
			url = prop.getProperty("url");
			username = prop.getProperty("username");
			password = prop.getProperty("password");
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			if (in != null) {
				try {
					in.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}
	}

	/**
	 * ȡ
	 * 
	 * @return
	 * @throws SQLException
	 */
	public static Connection getConnection() throws SQLException {
		return DriverManager.getConnection(url, username, password);
	}
	public static void main(String[] args) {
		try {
			// DBUtil.get();
			DBUtil.getConnection();
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}
}
