package hls.plugin.weixin.qiye;
import hls.plugin.weixin.common.HttpUtil;

import java.util.Map;
import net.sf.json.JSONException;
import net.sf.json.JSONObject;

public class WXupAndDown {
	/**
	 * token
	 * @param acceToken_urlx url
	 * @return
	 */
	public static String getJSSDKAccessToken(String acceToken_urlx) {
		String returnString = "";
		String requestUrl = acceToken_urlx;
		JSONObject jsonObject = JSONObject.fromObject(HttpUtil.httpRequestUrl(
				requestUrl, "GET")); // Http GET
		// ɹ
		if (null != jsonObject) {
			try {
				returnString = jsonObject.getString("access_token");
			} catch (JSONException e) {
				returnString = null;
			}
		}
		return returnString;
	}
/**
 * ticket
 * @param access_token token
 * @param ticket_urlx ticketַ
 * @return
 */
	public static String getJSSDKTicket(String access_token, String ticket_urlx) {
		String returnString = "";
		String requestUrl = ticket_urlx.replace("ACCESS_TOKEN", access_token);

		JSONObject jsonObject = JSONObject.fromObject(HttpUtil.httpRequestUrl(
				requestUrl, "GET"));
		// ɹ
		if (null != jsonObject) {
			try {
				returnString = jsonObject.getString("ticket");
			} catch (JSONException e) {
				returnString = null;
			}
		}
		return returnString;
	}
/**
 * ǩ
 * @param id ˺
 * @param secrect 
 * @param url صַ
 * @return
 */
	public static Map<String, String> getSignture(String id, String secrect,
			String url) {
		String  acceToken_urlx="https://qyapi.weixin.qq.com/cgi-bin/gettoken?corpid="+id+"&corpsecret="+secrect;
		String ticket_urlx="https://qyapi.weixin.qq.com/cgi-bin/get_jsapi_ticket?access_token=ACCESS_TOKEN";
		String js_accessToken = WXupAndDown.getJSSDKAccessToken(acceToken_urlx); // ȡ΢jssdk---access_token
		String jsapi_ticket = WXupAndDown.getJSSDKTicket(js_accessToken,ticket_urlx); // ȡ΢jssdk---ticket
		// System.out.println("jsapi_ticket==="+jsapi_ticket);
		Map<String, String> map = WxJSsign.sign(jsapi_ticket, url);
		return map;
	}
	
	 public static void main(String[] args) {
			 String id ="wx4257809fde0f5986";
			 String secrect="iTgSpAaEYejcyPBLlyikzx6kvSVuiMBxotfAkAdWAKo6nF8cefdJSTgLXqivXpZ7"; 
			 String url="http://cmsplus.com.cn";
			  
		  Map<String, String> map = getSignture(id,secrect,url);
		  	  System.out.println("1"+map.get("nonceStr"));
			  System.out.println("2"+map.get("timestamp"));
			  System.out.println("3"+map.get("signature")); 
			  } 
}