package hls.plugin.weixin.fuwu;

import net.sf.json.JSONException;
import net.sf.json.JSONObject;
import hls.plugin.weixin.common.GetPropertiesValue;
import hls.plugin.weixin.common.HttpUtil;

public class GetOpenid {
	
	public String getAccessTokenURL(String code, String appid,
			String secret) {
		String mutiurl = "https://api.weixin.qq.com/sns/oauth2/access_token?appid="
				+ appid
				+ "&secret="
				+ secret
				+ "&code="
				+ code
				+ "&grant_type=authorization_code";
		return mutiurl;
	}

	public String run(String code, String appid, String secret) {
		String openid = "";
		GetPropertiesValue gp = new GetPropertiesValue();
		String requestUrl = getAccessTokenURL(code, appid, secret);
		JSONObject jsonObject = JSONObject.fromObject(HttpUtil.httpRequestUrl(
				requestUrl, "GET")); // Http GET
		// ɹ
		if (null != jsonObject) {
			try {
				openid = jsonObject.getString("openid");
			} catch (JSONException e) {
				openid = null;
			}
		}

		return openid;

	}
}
