package hls.plugin.weixin.qiye;

import hls.plugin.weixin.common.GetPropertiesValue;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.HttpURLConnection;
import java.net.URL;

public class WeiImagePostTo {

	/**
	 * ϴ΢ŷ
	 * 
	 * @param fileType
	 *            ļ
	 * @param filePath
	 *            ϴļ·
	 * @param id
	 *            ˺
	 * @param secret
	 *            
	 * @return
	 * @throws Exception
	 */

	public void send(String mediaId, String pck_id, String fileName,String filetype, String fileSize,String userId,String tableName,String table_pk_value) {
		GetPropertiesValue gp = new GetPropertiesValue();
		HttpURLConnection con = null;
		OutputStream out = null;

		InputStream in = null;
		InputStream inputStream = null;
		ByteArrayOutputStream baos = null;
		int length = 0;
		try {
			File file = new File(gp.GetValue().get("winXinSavePath") + "/"
					+ fileName + "." + filetype);
			if (!file.exists() || !file.isFile()) {
				throw new IOException("ļ");
			}
			/**
			 * һ
			 */
			String enCodemediaId = mediaId;
			URL urlObj = new URL(gp.GetValue().get("zuLinserviceUrl")
					+ "?mediaId=" + enCodemediaId + "&pck_id=" + pck_id
					+ "&fileName=" + fileName + "&filetype=" + filetype
					+ "&fileSize=" + fileSize+"&userId="+userId+"&tableName="+tableName+"&table_pk_value="+table_pk_value);

			con = (HttpURLConnection) urlObj.openConnection();
			
			// con.setDoInput(true);
			con.setDoOutput(true);
			con.setRequestProperty("Content-Length",fileSize);
			con.setRequestProperty("Content-type", "application/image");//൱Ҫûлرִ
			con.setRequestMethod("POST"); // PostʽύĬgetʽ
			//con.setUseCaches(false); // postʽʹû
			con.connect();
			// 
			out = con.getOutputStream();
			in = new FileInputStream(file);
			int bytes=-1;
			byte[] bufferOut = new byte[1024];
			while ((bytes = in.read(bufferOut)) != -1) {
				out.write(bufferOut, 0, bytes);
			}
			
			
			inputStream = con.getInputStream();
//			temp.close();
		} catch (Exception e) {
			System.out.println("쳣:" + e.getMessage());
		} finally {
			if (in != null) {
				try {
					in.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			if (out != null) {
				try {
					out.flush();
					out.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			if (con != null) {
				con.disconnect();
			}

			if (inputStream != null) {
				try {
					inputStream.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			if (baos != null) {
				try {
					baos.close();
				} catch (IOException e) {
					e.printStackTrace();
				}// ٶȡһ
			}

		}
	}

}
